diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/cosine-antenna-model.h ns-3.44/src/antenna/model/cosine-antenna-model.h
--- ns-3.43/src/antenna/model/cosine-antenna-model.h	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/cosine-antenna-model.h	2025-03-09 16:55:49.343371000 -0700
@@ -11,15 +11,15 @@
 
 #include "antenna-model.h"
 
-#include <ns3/object.h>
+#include "ns3/object.h"
 
 namespace ns3
 {
 
 /**
- * \ingroup antenna
+ * @ingroup antenna
  *
- * \brief Cosine Antenna Model
+ * @brief Cosine Antenna Model
  *
  * This class implements the cosine model, similarly to what is described in:
  * Cosine Antenna Element, Mathworks, Phased Array System Toolbox (Sep. 2020)
@@ -40,8 +40,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return The object TypeId.
+     * @brief Get the type ID.
+     * @return The object TypeId.
      */
     static TypeId GetTypeId();
 
@@ -50,52 +50,52 @@
 
     /**
      * Get the vertical 3 dB beamwidth of the cosine antenna model.
-     * \return the vertical beamwidth in degrees
+     * @return the vertical beamwidth in degrees
      */
     double GetVerticalBeamwidth() const;
 
     /**
      * Get the horizontal 3 dB beamwidth of the cosine antenna model.
-     * \return the horizontal beamwidth in degrees
+     * @return the horizontal beamwidth in degrees
      */
     double GetHorizontalBeamwidth() const;
 
     /**
      * Get the horizontal orientation of the antenna element.
-     * \return the horizontal orientation in degrees
+     * @return the horizontal orientation in degrees
      */
     double GetOrientation() const;
 
   private:
     /**
      * Set the vertical 3 dB beamwidth (bilateral) of the cosine antenna model.
-     * \param verticalBeamwidthDegrees the vertical beamwidth in degrees
+     * @param verticalBeamwidthDegrees the vertical beamwidth in degrees
      */
     void SetVerticalBeamwidth(double verticalBeamwidthDegrees);
 
     /**
      * Set the horizontal 3 dB beamwidth (bilateral) of the cosine antenna model.
-     * \param horizontalBeamwidthDegrees the horizontal beamwidth in degrees
+     * @param horizontalBeamwidthDegrees the horizontal beamwidth in degrees
      */
     void SetHorizontalBeamwidth(double horizontalBeamwidthDegrees);
 
     /**
      * Set the horizontal orientation of the antenna element.
-     * \param orientationDegrees the horizontal orientation in degrees
+     * @param orientationDegrees the horizontal orientation in degrees
      */
     void SetOrientation(double orientationDegrees);
 
     /**
      * Compute the exponent of the cosine antenna model from the beamwidth
-     * \param beamwidthDegrees the beamwidth in degrees
-     * \return the exponent
+     * @param beamwidthDegrees the beamwidth in degrees
+     * @return the exponent
      */
     static double GetExponentFromBeamwidth(double beamwidthDegrees);
 
     /**
      * Compute the beamwidth of the cosine antenna model from the exponent
-     * \param exponent the exponent
-     * \return beamwidth in degrees
+     * @param exponent the exponent
+     * @return beamwidth in degrees
      */
     static double GetBeamwidthFromExponent(double exponent);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/isotropic-antenna-model.cc ns-3.44/src/antenna/model/isotropic-antenna-model.cc
--- ns-3.43/src/antenna/model/isotropic-antenna-model.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/isotropic-antenna-model.cc	2025-03-09 16:55:49.343371000 -0700
@@ -10,8 +10,8 @@
 
 #include "antenna-model.h"
 
-#include <ns3/double.h>
-#include <ns3/log.h>
+#include "ns3/double.h"
+#include "ns3/log.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/isotropic-antenna-model.h ns-3.44/src/antenna/model/isotropic-antenna-model.h
--- ns-3.43/src/antenna/model/isotropic-antenna-model.h	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/isotropic-antenna-model.h	2025-03-09 16:55:49.343371000 -0700
@@ -11,15 +11,15 @@
 
 #include "antenna-model.h"
 
-#include <ns3/object.h>
+#include "ns3/object.h"
 
 namespace ns3
 {
 
 /**
- * \ingroup antenna
+ * @ingroup antenna
  *
- * \brief Isotropic antenna model
+ * @brief Isotropic antenna model
  *
  * This is the simplest antenna model. The gain of this antenna is the same in all directions.
  */
@@ -29,8 +29,8 @@
     IsotropicAntennaModel();
 
     /**
-     * \brief Get the type ID.
-     * \return The object TypeId.
+     * @brief Get the type ID.
+     * @return The object TypeId.
      */
     static TypeId GetTypeId();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/parabolic-antenna-model.cc ns-3.44/src/antenna/model/parabolic-antenna-model.cc
--- ns-3.43/src/antenna/model/parabolic-antenna-model.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/parabolic-antenna-model.cc	2025-03-09 16:55:49.343371000 -0700
@@ -10,8 +10,8 @@
 
 #include "antenna-model.h"
 
-#include <ns3/double.h>
-#include <ns3/log.h>
+#include "ns3/double.h"
+#include "ns3/log.h"
 
 #include <cmath>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/parabolic-antenna-model.h ns-3.44/src/antenna/model/parabolic-antenna-model.h
--- ns-3.43/src/antenna/model/parabolic-antenna-model.h	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/parabolic-antenna-model.h	2025-03-09 16:55:49.343371000 -0700
@@ -11,15 +11,15 @@
 
 #include "antenna-model.h"
 
-#include <ns3/object.h>
+#include "ns3/object.h"
 
 namespace ns3
 {
 
 /**
- * \ingroup antenna
+ * @ingroup antenna
  *
- * \brief  Antenna model based on a parabolic approximation of the main lobe radiation pattern.
+ * @brief  Antenna model based on a parabolic approximation of the main lobe radiation pattern.
  *
  * This class implements the parabolic model as described in some 3GPP document, e.g., R4-092042
  *
@@ -36,8 +36,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return The object TypeId.
+     * @brief Get the type ID.
+     * @return The object TypeId.
      */
     static TypeId GetTypeId();
 
@@ -47,22 +47,22 @@
     // attribute getters/setters
     /**
      * Set the Beam width
-     * \param beamwidthDegrees Beam width in degrees
+     * @param beamwidthDegrees Beam width in degrees
      */
     void SetBeamwidth(double beamwidthDegrees);
     /**
      * Get the Beam width
-     * \return beam width in degrees
+     * @return beam width in degrees
      */
     double GetBeamwidth() const;
     /**
      * Set the antenna orientation
-     * \param orientationDegrees antenna orientation in degrees
+     * @param orientationDegrees antenna orientation in degrees
      */
     void SetOrientation(double orientationDegrees);
     /**
      * Get the antenna orientation
-     * \return antenna orientation in degrees
+     * @return antenna orientation in degrees
      */
     double GetOrientation() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/phased-array-model.cc ns-3.44/src/antenna/model/phased-array-model.cc
--- ns-3.43/src/antenna/model/phased-array-model.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/phased-array-model.cc	2025-03-09 16:55:49.343371000 -0700
@@ -8,16 +8,17 @@
 
 #include "isotropic-antenna-model.h"
 
-#include <ns3/boolean.h>
-#include <ns3/double.h>
-#include <ns3/log.h>
-#include <ns3/pointer.h>
-#include <ns3/uinteger.h>
+#include "ns3/boolean.h"
+#include "ns3/double.h"
+#include "ns3/log.h"
+#include "ns3/pointer.h"
+#include "ns3/uinteger.h"
 
 namespace ns3
 {
 
 uint32_t PhasedArrayModel::m_idCounter = 0;
+SymmetricAdjacencyMatrix<bool> PhasedArrayModel::m_outOfDateAntennaPairChannel;
 
 NS_LOG_COMPONENT_DEFINE("PhasedArrayModel");
 
@@ -27,6 +28,8 @@
     : m_isBfVectorValid{false}
 {
     m_id = m_idCounter++;
+    m_outOfDateAntennaPairChannel.AddRow();
+    m_outOfDateAntennaPairChannel.SetValueAdjacent(m_id, true);
 }
 
 PhasedArrayModel::~PhasedArrayModel()
@@ -137,4 +140,21 @@
     return m_id;
 }
 
+bool
+PhasedArrayModel::IsChannelOutOfDate(Ptr<const PhasedArrayModel> antennaB) const
+{
+    // Check that channel needs update
+    bool needsUpdate = m_outOfDateAntennaPairChannel.GetValue(m_id, antennaB->m_id);
+
+    // Assume the channel will be updated (needsUpdate == true), reset these
+    m_outOfDateAntennaPairChannel.SetValue(m_id, antennaB->m_id, false);
+    return needsUpdate;
+}
+
+void
+PhasedArrayModel::InvalidateChannels() const
+{
+    m_outOfDateAntennaPairChannel.SetValueAdjacent(m_id, true);
+}
+
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/phased-array-model.h ns-3.44/src/antenna/model/phased-array-model.h
--- ns-3.43/src/antenna/model/phased-array-model.h	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/phased-array-model.h	2025-03-09 16:55:49.343371000 -0700
@@ -10,8 +10,9 @@
 #include "angles.h"
 #include "antenna-model.h"
 
-#include <ns3/matrix-array.h>
-#include <ns3/object.h>
+#include "ns3/matrix-array.h"
+#include "ns3/object.h"
+#include "ns3/symmetric-adjacency-matrix.h"
 
 #include <complex>
 
@@ -19,9 +20,9 @@
 {
 
 /**
- * \ingroup antenna
+ * @ingroup antenna
  *
- * \brief Class implementing the phased array model virtual base class.
+ * @brief Class implementing the phased array model virtual base class.
  */
 class PhasedArrayModel : public Object
 {
@@ -37,8 +38,8 @@
     ~PhasedArrayModel() override;
 
     /**
-     * \brief Get the type ID.
-     * \return The object TypeId.
+     * @brief Get the type ID.
+     * @return The object TypeId.
      */
     static TypeId GetTypeId();
 
@@ -46,10 +47,10 @@
     using ComplexVector = ComplexMatrixArray; //!< the underlying Valarray
 
     /**
-     * \brief Computes the Frobenius norm of the complex vector
+     * @brief Computes the Frobenius norm of the complex vector
      *
-     * \param complexVector on which to calculate Frobenius norm
-     * \return the Frobenius norm of the complex vector
+     * @param complexVector on which to calculate Frobenius norm
+     * @return the Frobenius norm of the complex vector
      */
     double norm(const ComplexVector& complexVector) const
     {
@@ -62,194 +63,211 @@
     }
 
     /**
-     * \brief Returns the location of the antenna element with the specified
+     * @brief Returns the location of the antenna element with the specified
      * index, normalized with respect to the wavelength.
-     * \param index the index of the antenna element
-     * \return the 3D vector that represents the position of the element
+     * @param index the index of the antenna element
+     * @return the 3D vector that represents the position of the element
      */
     virtual Vector GetElementLocation(uint64_t index) const = 0;
 
     /**
-     * \brief Returns the number of antenna elements
-     * \return the number of antenna elements
+     * @brief Returns the number of antenna elements
+     * @return the number of antenna elements
      */
     virtual size_t GetNumElems() const = 0;
 
     /**
-     * \brief Returns the horizontal and vertical components of the antenna element field
+     * @brief Returns the horizontal and vertical components of the antenna element field
      * pattern at the specified direction. Single polarization is considered.
-     * \param a the angle indicating the interested direction
-     * \param polIndex the index of the polarization for which will be retrieved the field
+     * @param a the angle indicating the interested direction
+     * @param polIndex the index of the polarization for which will be retrieved the field
      * pattern
-     * \return a pair in which the first element is the horizontal component of the field
+     * @return a pair in which the first element is the horizontal component of the field
      * pattern and the second element is the vertical component of the field pattern
      */
     virtual std::pair<double, double> GetElementFieldPattern(Angles a,
                                                              uint8_t polIndex = 0) const = 0;
 
     /**
-     * \brief Set the vertical number of ports
-     * \param nPorts the vertical number of ports
+     * @brief Set the vertical number of ports
+     * @param nPorts the vertical number of ports
      */
     virtual void SetNumVerticalPorts(uint16_t nPorts) = 0;
 
     /**
-     * \brief Set the horizontal number of ports
-     * \param nPorts the horizontal number of ports
+     * @brief Set the horizontal number of ports
+     * @param nPorts the horizontal number of ports
      */
     virtual void SetNumHorizontalPorts(uint16_t nPorts) = 0;
 
     /**
-     * \brief Get the vertical number of ports
-     * \return the vertical number of ports
+     * @brief Get the vertical number of ports
+     * @return the vertical number of ports
      */
     virtual uint16_t GetNumVerticalPorts() const = 0;
 
     /**
-     * \brief Get the horizontal number of ports
-     * \return the horizontal number of ports
+     * @brief Get the horizontal number of ports
+     * @return the horizontal number of ports
      */
     virtual uint16_t GetNumHorizontalPorts() const = 0;
 
     /**
-     * \brief Get the number of ports
-     * \return the number of ports
+     * @brief Get the number of ports
+     * @return the number of ports
      */
     virtual uint16_t GetNumPorts() const = 0;
 
     /**
-     * \brief Get the number of polarizations
-     * \return the number of polarizations
+     * @brief Get the number of polarizations
+     * @return the number of polarizations
      */
     virtual uint8_t GetNumPols() const = 0;
 
     /**
-     * \brief Get the vertical number of antenna elements per port
-     * \return the vertical number of antenna elements per port
+     * @brief Get the vertical number of antenna elements per port
+     * @return the vertical number of antenna elements per port
      */
     virtual size_t GetVElemsPerPort() const = 0;
     /**
-     * \brief Get the horizontal number of antenna elements per port
-     * \return the horizontal number of antenna elements per port
+     * @brief Get the horizontal number of antenna elements per port
+     * @return the horizontal number of antenna elements per port
      */
     virtual size_t GetHElemsPerPort() const = 0;
 
     /**
-     * \brief Get the number of elements per port
-     * \return the number of elements per port
+     * @brief Get the number of elements per port
+     * @return the number of elements per port
      */
     virtual size_t GetNumElemsPerPort() const = 0;
 
     /**
-     * \brief Set the number of columns
-     * \param nColumns the number of columns to be set
+     * @brief Set the number of columns
+     * @param nColumns the number of columns to be set
      */
     virtual void SetNumColumns(uint32_t nColumns) = 0;
 
     /**
-     * \brief Set the number of rows
-     * \param nRows the number of rows to be set
+     * @brief Set the number of rows
+     * @param nRows the number of rows to be set
      */
     virtual void SetNumRows(uint32_t nRows) = 0;
 
     /**
-     * \brief Get the number of columns
-     * \return the number of columns in the antenna array
+     * @brief Get the number of columns
+     * @return the number of columns in the antenna array
      */
     virtual uint32_t GetNumColumns() const = 0;
 
     /**
-     * \brief Get the number of rows
-     * \return the number of rows in the antenna array
+     * @brief Get the number of rows
+     * @return the number of rows in the antenna array
      */
     virtual uint32_t GetNumRows() const = 0;
 
     /**
-     * \brief Get the polarization slant angle
-     * \return the polarization slant angle
+     * @brief Get the polarization slant angle
+     * @return the polarization slant angle
      */
     virtual double GetPolSlant() const = 0;
 
     /**
-     * \brief Get the indication whether the antenna array is dual polarized
-     * \return Returns true if the antenna array is dual polarized
+     * @brief Get the indication whether the antenna array is dual polarized
+     * @return Returns true if the antenna array is dual polarized
      */
     virtual bool IsDualPol() const = 0;
 
     /**
-     * \brief Calculate the index in the antenna array from the port index and the element in the
+     * @brief Calculate the index in the antenna array from the port index and the element in the
      * port
-     * \param portIndex the port index
-     * \param subElementIndex the element index in the port
-     * \return the antenna element index in the antenna array
+     * @param portIndex the port index
+     * @param subElementIndex the element index in the port
+     * @return the antenna element index in the antenna array
      */
     virtual uint16_t ArrayIndexFromPortIndex(uint16_t portIndex,
                                              uint16_t subElementIndex) const = 0;
 
     /**
      * Returns the index of the polarization to which belongs that antenna element
-     * \param elementIndex the antenna element for which will be returned the polarization index
-     * \return the polarization index
+     * @param elementIndex the antenna element for which will be returned the polarization index
+     * @return the polarization index
      */
     virtual uint8_t GetElemPol(size_t elementIndex) const = 0;
 
     /**
      * Sets the beamforming vector to be used
-     * \param beamformingVector the beamforming vector
+     * @param beamformingVector the beamforming vector
      */
     void SetBeamformingVector(const ComplexVector& beamformingVector);
 
     /**
      * Returns the beamforming vector that is currently being used
-     * \return the current beamforming vector
+     * @return the current beamforming vector
      */
     ComplexVector GetBeamformingVector() const;
 
     /**
      * Returns the const reference of the beamforming vector that is currently being used
-     * \return the const reference of the current beamforming vector
+     * @return the const reference of the current beamforming vector
      */
     const PhasedArrayModel::ComplexVector& GetBeamformingVectorRef() const;
 
     /**
      * Returns the beamforming vector that points towards the specified position
-     * \param a the beamforming angle
-     * \return the beamforming vector
+     * @param a the beamforming angle
+     * @return the beamforming vector
      */
     ComplexVector GetBeamformingVector(Angles a) const;
 
     /**
      * Returns the steering vector that points toward the specified position
-     * \param a the steering angle
-     * \return the steering vector
+     * @param a the steering angle
+     * @return the steering vector
      */
     ComplexVector GetSteeringVector(Angles a) const;
 
     /**
      * Sets the antenna model to be used
-     * \param antennaElement the antenna model
+     * @param antennaElement the antenna model
      */
     void SetAntennaElement(Ptr<AntennaModel> antennaElement);
 
     /**
      * Returns a pointer to the AntennaModel instance used to model the elements of the array
-     * \return pointer to the AntennaModel instance
+     * @return pointer to the AntennaModel instance
      */
     Ptr<const AntennaModel> GetAntennaElement() const;
 
     /**
      * Returns the ID of this antenna array instance
-     * \return the ID value
+     * @return the ID value
      */
     uint32_t GetId() const;
 
+    /**
+     * Returns whether the channel needs to be updated due to antenna setting changes.
+     * @param antennaB the second antenna of the pair for the channel we want to check
+     * @return whether a channel update is needed due to antenna settings changes
+     */
+    bool IsChannelOutOfDate(Ptr<const PhasedArrayModel> antennaB) const;
+
   protected:
+    /**
+     * After changing the antenna settings, InvalidateChannels() should be called to mark
+     * up-to-date channels as out-of-date
+     */
+    void InvalidateChannels() const;
+
     ComplexVector m_beamformingVector;  //!< the beamforming vector in use
     Ptr<AntennaModel> m_antennaElement; //!< the model of the antenna element in use
     bool m_isBfVectorValid;             //!< ensures the validity of the beamforming vector
     static uint32_t
         m_idCounter;  //!< the ID counter that is used to determine the unique antenna array ID
     uint32_t m_id{0}; //!< the ID of this antenna array instance
+    static SymmetricAdjacencyMatrix<bool>
+        m_outOfDateAntennaPairChannel; //!< matrix indicating whether a channel matrix between a
+                                       //!< pair of antennas needs to be updated after a change in
+                                       //!< one of the antennas configurations
 };
 
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/three-gpp-antenna-model.cc ns-3.44/src/antenna/model/three-gpp-antenna-model.cc
--- ns-3.43/src/antenna/model/three-gpp-antenna-model.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/three-gpp-antenna-model.cc	2025-03-09 16:55:49.343371000 -0700
@@ -8,8 +8,9 @@
 
 #include "antenna-model.h"
 
-#include <ns3/double.h>
-#include <ns3/log.h>
+#include "ns3/double.h"
+#include "ns3/enum.h"
+#include "ns3/log.h"
 
 #include <cmath>
 
@@ -23,20 +24,34 @@
 TypeId
 ThreeGppAntennaModel::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::ThreeGppAntennaModel")
-                            .SetParent<AntennaModel>()
-                            .SetGroupName("Antenna")
-                            .AddConstructor<ThreeGppAntennaModel>();
+    static TypeId tid =
+        TypeId("ns3::ThreeGppAntennaModel")
+            .SetParent<AntennaModel>()
+            .SetGroupName("Antenna")
+            .AddConstructor<ThreeGppAntennaModel>()
+            .AddAttribute(
+                "RadiationPattern",
+                "Radiation pattern of 3GPP antenna model",
+                EnumValue<RadiationPattern>(RadiationPattern::OUTDOOR),
+                MakeEnumAccessor<RadiationPattern>(&ThreeGppAntennaModel::SetRadiationPattern,
+                                                   &ThreeGppAntennaModel::GetRadiationPattern),
+                MakeEnumChecker<RadiationPattern>(RadiationPattern::OUTDOOR,
+                                                  "Outdoor",
+                                                  RadiationPattern::INDOOR,
+                                                  "Indoor"));
     return tid;
 }
 
 ThreeGppAntennaModel::ThreeGppAntennaModel()
-    : m_verticalBeamwidthDegrees{65},
-      m_horizontalBeamwidthDegrees{65},
-      m_aMax{30},
-      m_slaV{30},
-      m_geMax{8.0}
 {
+    SetRadiationPattern(RadiationPattern::OUTDOOR);
+}
+
+void
+ThreeGppAntennaModel::DoInitialize()
+{
+    NS_LOG_FUNCTION(this);
+    SetRadiationPattern(m_radiationPattern);
 }
 
 ThreeGppAntennaModel::~ThreeGppAntennaModel()
@@ -55,6 +70,49 @@
     return m_horizontalBeamwidthDegrees;
 }
 
+void
+ThreeGppAntennaModel::SetRadiationPattern(RadiationPattern pattern)
+{
+    m_radiationPattern = pattern;
+    switch (pattern)
+    {
+    case RadiationPattern::OUTDOOR:
+        SetOutdoorAntennaPattern();
+        break;
+    case RadiationPattern::INDOOR:
+        SetIndoorAntennaPattern();
+        break;
+    default:
+        NS_ABORT_MSG("Unknown radiation pattern");
+    }
+}
+
+ThreeGppAntennaModel::RadiationPattern
+ThreeGppAntennaModel::GetRadiationPattern() const
+{
+    return m_radiationPattern;
+}
+
+void
+ThreeGppAntennaModel::SetOutdoorAntennaPattern()
+{
+    m_verticalBeamwidthDegrees = 65;
+    m_horizontalBeamwidthDegrees = 65;
+    m_aMax = 30;
+    m_slaV = 30;
+    m_geMax = 8;
+}
+
+void
+ThreeGppAntennaModel::SetIndoorAntennaPattern()
+{
+    m_verticalBeamwidthDegrees = 90;
+    m_horizontalBeamwidthDegrees = 90;
+    m_aMax = 25;
+    m_slaV = 25;
+    m_geMax = 5;
+}
+
 double
 ThreeGppAntennaModel::GetSlaV() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/three-gpp-antenna-model.h ns-3.44/src/antenna/model/three-gpp-antenna-model.h
--- ns-3.43/src/antenna/model/three-gpp-antenna-model.h	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/three-gpp-antenna-model.h	2025-03-09 16:55:49.343371000 -0700
@@ -9,25 +9,34 @@
 
 #include "antenna-model.h"
 
-#include <ns3/object.h>
+#include "ns3/object.h"
 
 namespace ns3
 {
 
 /**
- * \brief  Antenna model based on a parabolic approximation of the main lobe radiation pattern.
+ * @brief  Antenna model based on a parabolic approximation of the main lobe radiation pattern.
  *
  * This class implements the parabolic model as described in 3GPP TR 38.901 v15.0.0
  */
 class ThreeGppAntennaModel : public AntennaModel
 {
   public:
+    /**
+     * The different antenna radiation patterns defined in ITU-R M.2412.
+     */
+    enum class RadiationPattern
+    {
+        OUTDOOR,
+        INDOOR
+    };
+
     ThreeGppAntennaModel();
     ~ThreeGppAntennaModel() override;
 
     /**
-     * \brief Get the type ID.
-     * \return The object TypeId.
+     * @brief Get the type ID.
+     * @return The object TypeId.
      */
     static TypeId GetTypeId();
 
@@ -36,35 +45,62 @@
 
     /**
      * Get the vertical beamwidth of the antenna element.
-     * \return the vertical beamwidth in degrees
+     * @return the vertical beamwidth in degrees
      */
     double GetVerticalBeamwidth() const;
 
     /**
      * Get the horizontal beamwidth of the antenna element.
-     * \return the horizontal beamwidth in degrees
+     * @return the horizontal beamwidth in degrees
      */
     double GetHorizontalBeamwidth() const;
 
     /**
+     * Set the antenna radiation pattern
+     * @param pattern the antenna radiation pattern to used
+     */
+    void SetRadiationPattern(RadiationPattern pattern);
+
+    /**
+     * Get the antenna radiation pattern
+     * @return the radiation pattern of the antenna
+     */
+    RadiationPattern GetRadiationPattern() const;
+
+    /**
      * Get the side-lobe attenuation in the vertical direction of the antenna element.
-     * \return side-lobe attenuation in the vertical direction in dB
+     * @return side-lobe attenuation in the vertical direction in dB
      */
     double GetSlaV() const;
 
     /**
      * Get the maximum attenuation of the antenna element.
-     * \return the maximum attenuation in dB
+     * @return the maximum attenuation in dB
      */
     double GetMaxAttenuation() const;
 
     /**
      * Get the maximum directional gain of the antenna element.
-     * \return the maximum directional gain in dBi
+     * @return the maximum directional gain in dBi
      */
     double GetAntennaElementGain() const;
 
   private:
+    // Inherited from Object.
+    // Waits for the attribute values to be set before setting the radiation pattern values
+    void DoInitialize() override;
+
+    /**
+     * Set the radiation pattern Dense Urban – eMBB, Rural – eMBB, Urban Macro – mMTC, and Urban
+     * Macro - URLLC, Table 8-6 in Report ITU-R M.2412
+     */
+    void SetOutdoorAntennaPattern();
+
+    /**
+     * Set the radiation pattern for Indoor Hotspot - eMBB,  Table 8-7 in Report ITU-R M.2412
+     */
+    void SetIndoorAntennaPattern();
+
     double m_verticalBeamwidthDegrees; //!< beamwidth in the vertical direction \f$(\theta_{3dB})\f$
                                        //!< [deg]
     double m_horizontalBeamwidthDegrees; //!< beamwidth in the horizontal direction
@@ -72,6 +108,7 @@
     double m_aMax;                       //!< maximum attenuation (A_{max}) [dB]
     double m_slaV;  //!< side-lobe attenuation in the vertical direction (SLA_V) [dB]
     double m_geMax; //!< maximum directional gain of the antenna element (G_{E,max}) [dBi]
+    RadiationPattern m_radiationPattern; //!< current antenna radiation pattern
 };
 
 } // namespace ns3
